#ifndef __EXT2_WRITE_H
#define __EXT2_WRITE_H

#include <ext2.h>

// Cuantos bloques se deben prealocar cuando un archivo necesita mas bloques
// ya sea porque fue recien creado, o porque esta escribiendo y se quedo sin 
// lugar
#define PREALLOC_BLOCK_COUNT 8

uint32_t ext2_balloc(fs_info* info, fs_file* file);
uint32_t ext2_ialloc(fs_info* info, fs_dir* parent);

uint32_t ext2_set_resvd_inodes(fs_info* info, uint32_t from, uint32_t count,
                               bool reserve);
uint32_t ext2_set_resvd_blocks(fs_info* info, uint32_t from, uint32_t count,
                               bool reserve);

uint64_t ext2_needed_blocks(fs_info* info, fs_file* file);
uint32_t ext2_assign_blocks(fs_info* info, fs_file* file);
uint32_t ext2_request_block(fs_info* info, fs_file* file);
uint32_t ext2_get_next_prealloc(fs_file* file);

uint32_t ext2_restore_backup(const fs_info* info);
uint64_t ext2_new_group(fs_info* info);

uint32_t ext2_has_super(const fs_info* info, uint64_t group);
uint32_t ext2_group_first_block(fs_info* info);

uint32_t ext2_unassign_block(fs_info* info, fs_file* file);
int64_t ext2_truncate(fs_info* info, fs_file* file, uint64_t length);

int32_t ext2_add_direntry(fs_info* info, fs_dir* dir, char* filename,
                          uint32_t inode, uint16_t filetype);

#endif
