#ifndef __LOADER_H__
#define __LOADER_H__

#include <types.h>
#include <elf.h>
#include <io.h>

typedef struct application_data {
	uint64_t entry_point;
    uint64_t running_status; // 1 si se está ejecutando una aplicación.
    uint64_t stack_pointer;  // Stack pointer antes de empezar a ejecutar.
    uint64_t exit_code;      // Código de terminación de la aplicación.
    uint64_t exit_core_id;   // Id del núcleo que efectivamente terminó.
    int64_t loader_error;    // Código de error del loader.
} application_data;

application_data *load_exec_elf64(int64_t fd, int argc, char *argv[]);

void execute_start();
void execute_end();

#endif  /* !__LOADER_H__*/
