#ifndef __PCI_H__
#define __PCI_H__
#include <ports.h>

uint32_t pci_read_config(uint16_t device, uint16_t field_and_size);
void check_function(uint16_t device);
void pci_check_buses(void);


struct class_info {
    uint8_t class;
    uint8_t subclass;
    char* info;
};

struct pci_device {
    uint16_t device_id;
    uint16_t vendor_id;
    uint8_t class;
    uint8_t subclass;
    uint8_t prog_if;
    uint8_t irq;
} __attribute__((__packed__));

#define FIELD(field, size) ((field << 8) | size)

#define HEADER_TYPE    FIELD(0x0E, 2)
#define VENDOR_ID      FIELD(0X00, 2)
#define DEVICE_ID      FIELD(0X02, 2)
#define CLASS          FIELD(0X0B, 1)
#define SUBCLASS       FIELD(0X0A, 1)
#define SECONDARY_BUS  FIELD(0X19, 1)
#define PROG_IF        FIELD(0X09, 1)
#define IRQ            FIELD(0X3C, 1)
#define BAR0           FIELD(0X10, 4)
#define BAR1           FIELD(0X14, 4)
#define BAR2           FIELD(0X18, 4)
#define BAR3           FIELD(0X1C, 4)
#define BAR4           FIELD(0X20, 4)
#define BAR5           FIELD(0X24, 4)

#endif
