%include "defines.mac"

global reset_stack_awe
global ap_long_mode

;; Timed sleep
extern sleep

;; LAPIC
extern local_apic_address
extern lapic_turn_on

;; Core Management
extern core_id_table
extern core_id_count

;; App Data
extern app_data

ap_long_mode:
    ; ======== CODIGO DE APS ========
    ; Como no se tiene pila alguna, llamar a una función no es una opción
    ; Es necesario implementar core_id inline acá 
    ; para saber con certeza la pila que corresponde.
    ; Con esto al tiene el lapic_id
    mov eax, [local_apic_address]
    ; El ID está en el offset 0x20
    mov eax, [eax + 0x20]
    shr eax, 24
    ; Con esto tengo un puntero a tabla de core_ids en rsi
    mov rsi, core_id_table
    ; Con esto tengo la cantidad de cores en rcx. O sea que puedo hacer loop.
    mov rcx, [core_id_count] 
    ; La pila va a partir de KERNEL_STACK_BSP (expand down, OJO)
    mov esp, KERNEL_STACK_BSP
    .get_id_inline:
        cmp al, [rsi + rbx]
        je .gotten
        add rbx, 1
        add esp, KERNEL_STACK_SIZE
        loop .get_id_inline
    ; WARNING: Si llega aca las cosas estan muy mal
    jmp sleep_halt
    .gotten:
    ; Armo el stack frame y alineo la pila
    push rbp
    push rbp
    mov rbp, rsp
    ; Prendemos el Local APIC del AP
    call lapic_turn_on
    sti

    ; El syscall exit en los ap tiene que devolver 
    ; el flujo de ejecución a esta etiqueta
reset_stack_awe: 
    ; La pila tiene al menos dos elementos, que son los RBP pusheados
    ; WARNING: Si no fuese así esto lo dejaría en la pila de otro o en el heap
    ; Con el and y la suma vuelve a su estado original
    ; Sería el próximo múltiplo de KERNEL_STACK_SIZE menos 16 de la base
    mov eax, KERNEL_STACK_SIZE
    mov rbx, rax
    not rax
    and rsp, rax
    lea rsp, [rsp + rbx - 16]  
    mov r12, app_data
wait_execute:
    mov rdi, 500    ; Valor arbitrario, revisar antes de probar en una máquina real
    call sleep       ; Depende de las interrupciones de reloj
    cmp qword [r12 + APP_DATA_RUNNING_STATUS], 1
    jne wait_execute
    jmp [r12 + APP_DATA_ENTRY_POINT]
    
    ; Nadie debería llegar acá.
sleep_halt:
    xchg bx, bx
    hlt
    jmp sleep_halt
