%include "apic_macros.mac"
%include "defines.mac"

global long_mode

;; IDT
extern IDT_DESC

;; Kernel
extern kernel_main

;; AP
extern ap_long_mode

;-----------------------------------------------------------------------------
;-------------------------- comienzo modo largo ------------------------------
;-----------------------------------------------------------------------------

BITS 64

section .text

; Aca saltan tanto el BSP como los AP, recordar que los AP aun no tienen stack
long_mode:
    ; Limpio los registros
    xor eax, eax
    xor ebx, ebx
    xor ecx, ecx
    xor edx, edx
    xor esi, esi
    xor edi, edi
    xor ebp, ebp
    xor esp, esp
    xor r8, r8
    xor r9, r9
    xor r10, r10
    xor r11, r11
    xor r12, r12
    xor r13, r13
    xor r14, r14
    xor r15, r15
    ; Levanto la IDT (Ojo no esta inicializada aun si soy bsp)
    lidt [IDT_DESC]

.enable_sse: ;Taken from osdev
    mov rax, cr0
    and ax, 0xFFFB      ;clear coprocessor emulation CR0.EM
    or ax, 0x2          ;set coprocessor monitoring  CR0.MP
    mov cr0, rax
    mov rax, cr4
    or ax, 3 << 9       ;set CR4.OSFXSR and CR4.OSXMMEXCPT at the same time
    mov cr4, rax

    ; Salto si no soy el bsp
    jump_if_not_bsp ap_long_mode

    ; ======== CODIGO DE BSP ========
    ; Seteo la pila denuevo pero en 64 bits
    mov esp, KERNEL_STACK_BSP
    ; Armo el stack frame y alineo la pila
    push rbp
    push rbp
    mov rbp, rsp
    ; Inicializamos delirios
    jmp kernel_main
