%include "defines.mac"

global execute_start
global execute_end

;; App Data
extern app_data

section .text

BITS 64

; @param rdi int argc
; @param rsi char* argv[]
execute_start:
    ; Preservamos el entorno de ejecución del que venimos.
    pushfq
    push rbx
    push r12
    push r13
    push r14
    push r15
    push rbp

    mov rdx, app_data
    ; Sincronización por memoria
    mov qword [rdx + APP_DATA_RUNNING_STATUS], 1 
    mov qword [rdx + APP_DATA_STACK_POINTER], rsp
    jmp [rdx + APP_DATA_ENTRY_POINT]

execute_end:
    ; Restauro contexto.
    mov rdx, app_data
    mov qword rsp, [rdx + APP_DATA_STACK_POINTER]

    pop rbp
    pop r15
    pop r14
    pop r13
    pop r12
    pop rbx
    popfq
    ret
