#include <core_id.h>
#include <exception.h>
#include <lapic.h>

uint8_t core_id_table[MAX_PROCESSORS];
uint64_t core_id_count = 0;

void core_id_add(uint8_t apic_id) {
    core_id_table[core_id_count] = apic_id;
    core_id_count++;
}

uint64_t core_id() {
    uint8_t apic_id = lapic_get_id();
    for (uint64_t i = 0; i < core_id_count; i++)
        if (core_id_table[i] == apic_id)
            return i;
    KERNEL_PANIC("APIC ID %i no existente en el diccionario", apic_id);
    return -1;
}

uint64_t core_count() {
    return core_id_count;
}
