#include <syscall.h>

#define LIMIT 60
#define BUFSZ 100

int is_prime(unsigned int n){
    for(unsigned int i = 2; i < n; i++){
        if(n % i == 0) 
            return 0;
    }
    return 1;
}


unsigned int itoa(unsigned int i, char * buffer){
    unsigned int digitos = 0;
    unsigned int i_ = i;
    while (i_ > 0){
        digitos++;
        i_ /= 10;
    }

    unsigned int index = digitos;

    while (i > 0){
        buffer[--index] = i%10 + '0';
        i /= 10;
    }
    return digitos;
}


int main(int argc, char* argv[]) {
    uint64_t id = core_id();
    char buf[BUFSZ] = {0};
    if (id != 0) {
        while (1);
    } else {
        create("primos.txt", 0x8); // 0x8  = tipo de archivo
        int64_t fd = open("primos.txt");
        for(unsigned int n = 2; n < LIMIT; n++){
            if(is_prime(n)){ 
                unsigned int d = itoa(n, buf);
                write(fd, buf, d);
                write(fd, "\n", 1);
            }
        }
        write(1, "termino, leyendo del archivo...\n", 32);
        // vuelvo al principio
        seek(fd, 0, 0); // el segundo 0 es SEEK_SET
        create("primos_copia.txt", 0x8); // 0x8  = tipo de archivo
        int64_t fd2 = open("primos_copia.txt");
        int64_t r;
        do{
            r = read(fd, buf, BUFSZ);
            write(1, buf, r);
            write(fd2, buf, r);
        } while(r == BUFSZ);
        close(fd);
        close(fd2);
    }
	exit(0);
}

